Linux软件商店的困境
================================================================================
> 在调查了各种方案后，我认为Linux需要一个更好的在线软件零售商店。

有好几次，我恳求Ubuntu团队考虑改善现在的Ubuntu软件中心。它在旧电脑上几乎就不能用，而就算在主流硬件平台，它采用的软件安装方式还有很大改善空间，尤其是付费软件。

我希望这篇文章不仅能让我们认真了解一下目前存在的搜索和安装Linux软件的方式，也许还可以最终找到一种处理付费软件的方法。

### Linspire曾经很接近 ###

不管你喜欢不喜欢被[Xandros][2]收购之前的[Linspire][1]公司，实际上，它早期时候建立的点击运行软件店(CNR)在当时已经超前了许多年。在CNR变成一个尝试在所有发行版上处理所有事情的万能工具之前，Linspire还是提供了我认为对新手最友好的Linux平台软件安装方式。甚至以现在的标准来衡量，在统一环境下轻松地安装开源软件(FoSS)和商业应用这一点上，"经典的"CNR仍值得一提。

### 把Steam当作软件商店 ###

尽管在Linux桌面环境有很多"其他"可用的软件商店，但实际上没有哪个像Ubuntu软件中心那样支持付费应用。而我看到的唯一一个像Ubuntu软件中心那样可以在Linux桌面下发布付费应用的是Valve公司的[Steam][3]数字软件管理器，作为发行付费Linux游戏的商店而闻名。我发现Steam已经用来在其他平台[发行软件][4]，所以我认为，Steam也完全可以为Linxu用户发行付费软件。

不像其他软件发布工具，Steam专门设计了比其他Linux替代方案更为清晰的付费处理方式。而且，Steam用一种炫目的方式来展示游戏和软件的名字，所以，用户在浏览这些名字的时候能够选中适合自己需求的应用。

我并没有建议把Steam当作搜索开源软件的最佳替代方案，我坚决反对这种想法。我的建议是，Steam可以成为一个专门处理拥有专利的应用或游戏软件的跨发行版的选择。

### 诞生一个新生态系统 ###

现在，你也许认为我是一个坚决反对类似Ubuntu软件中心这样的软件发布工具。但事实是，我只是非常希望看到它被改善，并在尽可能多地开源软件上获得成功。再重申一下，尽管我觉得它还需要花点工夫，它还是一个不错的搜索软件的工具。但是就像我之前说过，总的来说，软件中心的付费系统没有提供良好的用户体验。它响应很慢，实际上也没有提供一个有效的工具来检查付费软件的新版本。

在这个舞台上，我认为Steam是毫无疑问的优胜者。而且如果我们能够让Steam更多地努力去推出人们实际上希望使用的付费软件－而不仅只限于列出目前Linux系统已有的有限选择－这将会带来几乎无限的需求。

想象一下这样一个新的生态系统，付费软件可以通过他们自己的发布工具轻松的发布而不用考虑具体的Linux发行版的依赖。Ubuntu，Arch，OpenSUSE，不管哪个发行版，我认为Steam是一个往Linux世界推出还未被移植软件的工具。在新软件被发布和应用后，更多的会跟上。也许我们甚至会看到大牌露脸？比如Adobe Photoshop和Microsoft Office－如果有愿意付费的用户，我想不到任何任何理由为什么它们不会参与进来。

### 困难和挑战 ###

在Steam能够统一Linux世界软件发布之前还存在一些重要的挑战。第一个挑战来自Linux用户自身：我们保持怀疑和保留态度，而且一直在担心，会不会是下一波"收费威胁"的到来。尽管Valve在通过Steam把游戏发行到不同的Linux发行版上时受到了热烈的欢迎，如果在各种软件都积极地推销过来时，我想这种"欢迎"会冷却一点。

另一个闪过我脑海的担心是，Valve是否会接受大量的"垃圾"应用，类似那些你可以在手机应用软件世界看到的。没有比在Steam商店里看到无数的垃圾应用反而优秀应用很难找到这种事情更糟糕的了。我希望我们可以在付费软件的数量和质量种寻找一个平衡。

### 没有Steam－没有问题? ###

我不是那种过于重视任意问题的单一解决方案的人，所以我承认，Steam本身也许并不是为Linux民众发布付费软件的唯一方式。但是，我的问题就会变成：如果没有Steam－还有其他方案吗？我们已经看到类似Ubuntu的发行版正在尝试提供付费软件，但是很明显，[结果][5]并没有那么好。

我也确实支持Ubuntu，他们所做的努力为软件中心带来了许多应用，多谢他们的[应用开发者活动周][6]。软件中心是个很好的想法，对于那些休闲应用，每次看看发布了哪些新应用也挺好玩的。但是，很可惜，它没有吸引到Adobe和Microsoft来提供那些高需求软件的非微软和苹果平台的版本。

最后，是否存在切实可行的替代方案让付费软件进入Linux世界呢？在企业领域，确实已经有了。

### 企业应用 ###

就我的个人经验来说，我真的不认为付费软件能够在Linux桌面上站稳脚跟，但是我却看到付费软件在未来Linux服务器上的广阔前景。像大多数Linux事物，是在服务器端赚的钱，靠的是提供服务和企业级产品。

所以就算Steam能够整合成为一个付费应用的发布平台，恐怕它也不能在企业领域获得太多关注。另一方面，也许我们将来会重新再回到这里，而Steam确实已经成为消费者发布付费Linux软件的地方，而不仅仅是优秀游戏。

--------------------------------------------------------------------------------

via: http://www.datamation.com/open-source/the-linux-software-store-conundrum-1.html

译者：[zpl1025](https://github.com/zpl1025) 校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[1]:http://en.wikipedia.org/wiki/Linspire
[2]:http://en.wikipedia.org/wiki/Xandros
[3]:http://en.wikipedia.org/wiki/Steam_(software)
[4]:http://store.steampowered.com/software/
[5]:http://developer.ubuntu.com/2013/04/top-10-ubuntu-app-downloads-for-march/
[6]:http://developer.ubuntu.com/2013/12/ubuntu-app-developer-week-call-for-papers/
