Linux能够提供消费者想要的东西吗？
================================================================================
> 由Jack Wallen提出的新观点，提供消费者想要的东西也许是收获无限成就的关键。

![](http://tr2.cbsistatic.com/hub/i/r/2014/08/14/ce90a81e-d17b-4b8f-bd5b-053120e305e6/resize/620x485/f5f9e0798798172d4e41edbedeb6b7e5/whattheyneedhero.png)

在消费电子的世界里，如果你不能提供购买者想要的东西，那他们就会跑去别家。我们最近在Firefox浏览器上就看过类似的事情。消费者想要的是一个快速而不那么臃肿的软件，而开发者们却走到了另外的方向上。最后，用户都转移到Chrome或Chromium上去了。

Linux需要深深凝视自己的水晶球，仔细体会那场浏览器大战留下的尘埃，然后留意一下这点建议：

> 如果你不能提供他们想要的，他们就会离开。

而这种事与愿违的另一个例子是Windows 8。消费者不喜欢那套界面。而微软却坚持使用，因为这是把所有东西搬到Surface平板上所必须的。相同的情况也可能发生在Canonical和Ubuntu Unity身上 -- 尽管它们的目标并不是单一独特地针对平板电脑来设计（所以，整套界面在桌面系统上仍然很实用而且直观）。

一直以来，Linux开发者和设计者们看上去都按照他们自己的想法来做事情。他们过分在意“吃你自家的狗粮”这句话了。以至于他们忘记了一件非常重要的事情：

> 没有新用户，他们的“根基”也仅仅只属于他们自己。

换句话说，唱诗班不仅仅是被传道，他们也同时在宣传。让我给你看三个案例来完全掌握这一点。

- 多年以来，一直有在Linux系统中替代活动目录（Active Directory）的需求。我很想把这个名称换成LDAP，但是你真的用过LDAP吗？那就是个噩梦。开发者们也努力了想让LDAP能易用一点，但是没一个做到了。而让我很震惊的是这样一个从多用户环境下发展起来的平台居然没有一个能和AD正面较量的功能。这需要一组开发人员，从头开始建立一个AD的开源替代。这对那些寻求从微软产品迁移的中型企业来说是非常大的福利。但是在这个产品做好之前，他们还不能开始迁移。
- 另一个从微软激发的需求是Exchange/Outlook。是，我也知道许多人都开始用云。但是，事实上中等和大型规模生意仍然依赖于Exchange/Outlook组合，直到能有更好的产品出现。而这将非常有希望发生在开源社区。整个拼图的一小块已经摆好了（虽然还需要一些工作）- 群件客户端，Evolution。如果有人能够从Zimbra拉出一个分支，然后重新设计成可以配合Evolution（甚至Thunderbird）来提供服务实现Exchange的简单替代，那这个游戏就不是这么玩了，而消费者获得的利益将是巨大的。
- 便宜，便宜，还是便宜。这是大多数人都得咽下去的苦药片 - 但是消费者（和生意）就是希望便宜。看看去年一年Chromebook的销量吧。现在，搜索一下Linux笔记本看能不能找到700美元以下的。而只用三分之一的价格，就可以买到一个让你够用的Chromebook（一个使用了Linux内核的平台）。但是因为Linux仍然是一个细分市场，很难降低成本。像红帽那种公司也许可以改变现状。他们也已经推出了服务器硬件。为什么不推出一些和Chromebook有类似定位但是却运行完整Linux环境的低价中档笔记本呢？（请看“[Cloudbook是Linux的未来吗？][1]”）其中的关键是这种设备要低成本并且符合普通消费者的要求。不要站在游戏玩家/开发者的角度去思考了，记住普通消费者真正的需求 - 一个网页浏览器，不会有更多了。这是Chromebook为什么可以这么轻松地成功。Google精确地知道消费者想要什么，然后推出相应的产品。而面对Linux，一些公司仍然认为他们吸引买家的唯一途径是高端昂贵的硬件。而有一点讽刺的是，口水战中最经常听到的却是Linux只能在更慢更旧的硬件上运行。

最后，Linux需要看一看乔布斯传（Book Of Jobs），搞清楚如何说服消费者们他们真正要的就是Linux。在公司里和在家里 -- 每个人都可以享受到Linux带来的好处。说真的，开源社区怎么可能做不到这点呢？Linux本身就已经带有很多漂亮的时髦术语标签：稳定性、可靠性、安全性、云、免费 -- 再加上Linux实际已经进入到绝大多数人手中了（只是他们自己还不清楚罢了）。现在是时候让他们知道这一点了。如果你是用Android或者Chromebooks，那么你就在用（某种形式上的）Linux。

搞清楚消费者需求一直以来都是Linux社区的绊脚石。而且我知道 -- 太多的Linux开发都基于某个开发者有个特殊的想法。这意味着这些开发都针对的“微型市场”。是时候了，无论如何，让Linux开发社区能够进行全球性思考了。“一般用户有什么需求，我们怎么满足他们？”让我提几个最基本的点。

一般用户想要：

- 低价
- 设备和服务能无缝衔接
- 直观而现代的设计
- 百分百可靠的浏览器体验

把这四点放在心中，应该可以轻松地以Linux为基础开发出用户实际需要的产品。Google做到了...当然Linux社区也可以参照Google的工作并开发出更好的产品。把这些应用到集成AD这件事上，能开发出Exchange/Outlook的替代或者基于云的群件工具，就会发生一件非常特殊的事 -- 人们会为它买单。

你觉得Linux社区能够提供消费者想要的东西吗？在下边的讨论区里分享一下你的看法。

--------------------------------------------------------------------------------

via: http://www.techrepublic.com/article/will-linux-ever-be-able-to-give-consumers-what-they-want/

作者：[Jack Wallen][a]
译者：[zpl1025](https://github.com/zpl1025)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[a]:http://www.techrepublic.com/search/?a=jack+wallen
[1]:http://www.techrepublic.com/article/is-the-cloudbook-the-future-of-linux/
