Larry Wall 专访——语言学、Perl 6 的设计和发布
================================================================================

> 经历了15年的打造，Perl 6 终将在年底与大家见面。我们预先采访了它的作者了解一下新特性。

Larry Wall 是个相当有趣的人。他是编程语言 Perl 的创造者，这种语言被广泛的誉为将互联网粘在一起的胶水，也由于大量地在各种地方使用非字母的符号被嘲笑为‘只写’语言——以难以阅读著称。Larry 本人具有语言学背景，以其介绍 Perl 未来发展的演讲“[洋葱的状态][1]（State of the Onion）”而闻名。（LCTT 译注：“洋葱的状态”是 Larry Wall 的年度演讲的主题，洋葱也是 Perl 基金会的标志。）

在2015年布鲁塞尔的 FOSDEM 上，我们赶上了 Larry，问了问他为什么 Perl 6 花了如此长的时间（Perl 5 的发布时间是1994年），了解当项目中的每个人都各执己见时是多么的难以管理，以及他的语言学背景自始至终究竟给 Perl 带来了怎样的影响。做好准备，让我们来领略其中的奥妙……

![](http://www.linuxvoice.com/wp-content/uploads/2015/07/wall1.jpg)

**Linux Voice：你曾经有过计划去寻找世界上某个地方的某种不见经传的语言，然后为它创造书写的文字，但你从未有机会去实现它。如果你能回到过去，你会去做么？**

Larry Wall：你首先得是个年轻人才能搞得定！做这些事需要投入很大的努力和人力，以至于已经不适合那些上了年纪的人了。健康、活力是其中的一部分，同样也因为人们在年轻的时候更容易学习一门新的语言，只有在你学会了语言之后你才能写呀。

我自学了日语十年，由于我的音系学和语音学的训练我能说的比较流利——但要理解别人的意思对我来说还十分困难。所以到了日本我会问路，但我听不懂他们的回答！

通常需要一门语言学习得足够好才能开发一个文字体系，并可以使用这种语言进行少量的交流。在你能够实际推广它和用本土人自己的文化教育他们前，那还需要一些年。最后才可以教授本土人如何以他们的文明书写。

当然如果在语言方面你有帮手 —— 经过别人的提醒我们不再使用“语言线人”来称呼他们了，那样显得我们像是在 CIA 工作的一样！—— 你可以通过他们的帮助来学习外语。他们不是老师，但他们会以另一种方式来启发你学习 —— 当然他们也能教你如何说。他们会拿着一根棍子，指着它说“这是一根棍子”，然后丢掉同时说“棒子掉下去了”。然后，你就可以记下一些东西并将其系统化。

大多数让人们有这样做的动力是翻译圣经。但是这只是其中的一方面；另一方面也是为了文化保护。传教士在这方面臭名昭著，因为人类学家认为人们应该基于自己的文明来做这件事。但有些人注定会改变他们的文化——他们可能是军队、或是商业侵入，如可口可乐或者缝纫机，或传教士。在这三者之间，传教士相对来讲伤害最小的了，如果他们恪守本职的话。

**LV：许多文字系统有本可依，相较而言你的发明就像是格林兰语…**

印第安人照搬字母就发明了他们自己的语言，而且没有在这些字母上施加太多我们给这些字母赋予的涵义，这种做法相当随性。它们只要能够表达出人们的所思所想，使交流顺畅就行。经常是有些声调语言（Tonal language）使用的是西方文字拼写，并尽可能的使用拉丁文的字符变化，然后用重音符或数字标注出音调。

在你开始学习如何使用语音和语调表示之后，你也开始变得迷糊——或者你的书写就不如从前准确。或者你对话的时候像在讲英文，但发音开始无法匹配拼写。

**LV：当你在开发 Perl 的时候，你的语言学背景会不会使你认为：“这对程序设计语言真的非常重要”？**

LW：我在人们是如何使用语言上想了很多。在现实的语言中，你有一套名词、动词和形容词的体系，并且你知道这些单词的词性。在现实的自然语言中，你时常将一个单词放到不同的位置。我所学的语言学理论也被称为法位学（phoenetic），它解释了这些在自然语言中工作的原理 ——  也就是有些你当做名词的东西，有时候你可以将它用作动词，并且人们总是这样做。

你能很好的将任何单词放在任何位置而进行沟通。我比较喜欢的例子是将一个整句用作为一个形容词。这句话会是这样的：“我不喜欢你的[我可以用任何东西来取代这个形容词的]态度”！

所以自然语言非常灵活，因为聆听者非常聪明 —— 至少，相对于电脑而言 —— 你相信他们会理解你最想表达的意思，即使存在歧义。当然对电脑而言，你必须保证歧义不大。

> “在 Perl 6 中，我们试图让电脑更准确的了解我们。”

可以说在 Perl 1到5上，我们针对歧义方面处理做得还不够。有时电脑会在不应该的时候迷惑。在 Perl 6上，我们找了许多方法，使得电脑对你所说的话能更准确的理解，就算用户并不清楚这底是字符串还是数字，电脑也能准确的知道它的类型。我们找到了内部以强类型存储，而仍然可以无视类型的“以此即彼”的方法。

![](http://www.linuxvoice.com/wp-content/uploads/2015/07/wall2.jpg)

**LV：Perl 被视作互联网上的“胶水（glue）”语言已久，能将点点滴滴组合在一起。在你看来 Perl 6 的发布是否符合当前用户的需要，或者旨在招揽更多新用户，能使它重获新生吗？**

LW：最初的设想是为 Perl 程序员带来更好的 Perl。但在看到了 Perl 5 上的不足后，很明显改掉这些不足会使 Perl 6更易用，就像我在讨论中提到过 —— 类似于 [托尔金（J. R. R. Tolkien） 在《指环王》前言中谈到的适用性一样][2]。

重点是“简单的东西应该简单，而困难的东西应该可以实现”。让我们回顾一下，在 Perl 2和3之间的那段时间。在 Perl 2上我们不能处理二进制数据或嵌入的 null 值 —— 只支持 C 语言风格的字符串。我曾说过“Perl 只是文本处理语言 —— 在文本处理语言里你并不需要这些功能”。

但当时发生了一大堆的问题，因为大多数的文本中会包含少量的二进制数据 —— 如网络地址（network addresses）及类似的东西。你使用二进制数据打开套接字，然后处理文本。所以通过支持二进制数据，语言的适用性（applicability）翻了一倍。

这让我们开始探讨在语言中什么应该简单。现在的 Perl 中有一条原则，是我们偷师了哈夫曼编码（Huffman coding）的做法，它在位编码系统中为字符采取了不同的尺寸，常用的字符占用的位数较少，不常用的字符占用的位数更多。

我们偷师了这种想法并将它作为 Perl 的一般原则，针对常用的或者说常输入的 —— 这些常用的东西必须简单或简洁。不过，另一方面，也显得更加的不规则（irregular）。在自然语言中也是这样的，最常用的动词实际上往往是最不规则的。

所以在这样的情况下需要更多的差异存在。我很喜欢一本书是 Umberto Eco 写的的《探寻完美的语言（The Search for the Perfect Language）》，说的并不是计算机语言；而是哲学语言，大体的意思是古代的语言也许是完美的，我们应该将它们带回来。

所有的这类语言错误的认为类似的事物其编码也应该总是类似的。但这并不是我们沟通的方式。如果你的农场中有许多动物，他们都有相近的名字，当你想杀一只鸡的时候说“走，去把 Blerfoo 宰了”，你的真实想法是宰了 Blerfee，但有可能最后死的是一头牛（LCTT 译注：这是杀鸡用牛刀的意思吗？哈哈）。

所以在这种时候我们其实更需要好好的将单词区分开，使沟通信道的冗余增加。常用的单词应该有更多的差异。为了达到更有效的通讯，还有一种自足（LCTT 译注：self-clocking ，自同步，[概念][3]来自电信和电子行业，此处译为“自足”更能体现涵义）编码。如果你在一个货物上看到过 UPC 标签（条形码），它就是一个自足编码，每对“条”和“空”总是以七个列宽为单位，据此你就知道“条”的宽度加起来总是这么宽。这就是自足。

在电子产品中还有另一种自足编码。在老式的串行传输协议中有停止和启动位，来保持同步。自然语言中也会包含这些。比如说，在写日语时，不用使用空格。由于书写方式的原因，他们会在每个词组的开头使用中文中的汉字字符，然后用音节表（syllabary）中的字符来结尾。

**LV：是平假名，对吗？**

LW: 是的，平假名。所以在这一系统，每个词组的开头就自然就很重要了。同样的，在古希腊，大多数的动词都是搭配好的（declined 或 conjugated），所以它们的标准结尾是一种自足机制。在他们的书写体系中空格也是可有可无的 —— 引入空格是更近代的发明。

所以在计算机语言上也要如此，有的值也可以自足编码。在 Perl 上我们重度依赖这种方法，而且在 Perl 6 上相较于前几代这种依赖更重。当你使用表达式时，你要么得到的是一个词，要么得到的是插值（infix）操作符。当你想要得到一个词，你有可能得到的是一个前缀操作符，它也在相同的位置；同样当你想要得到一个插值操作符，你也可能得到的是前一个词的后缀。

但是反过来。如果编译器准确的知道它想要什么，你可以稍微重载（overload）它们，其它的让 Perl 来完成。所以在斜线“/”后面是单词时它会当成正则表达式，而斜线“/”在字串中时视作除法。而我们并不会重载所有东西，因为那只会使你失去自足冗余。

多数情况下我们提示的比较好的语法错误消息，是出于发现了一行中出现了两个关键词，然后我们尝试找出为什么一行会出现两个关键字 —— “哦，你一定漏掉了上一行的分号”，所以我们相较于很多其他的按步照班的解析器可以生成更好的错误消息。

![](http://www.linuxvoice.com/wp-content/uploads/2015/07/wall3.jpg)

**LV：为什么 Perl 6 花了15年？当每个人对事物有不同看法时一定十分难于管理，而且正确和错误并不是绝对的。**

LW：这必须要非常小心地平衡。刚开始会有许多的好的想法 —— 好吧，我并不是说那些全是好的想法。也有很多令人烦恼的地方，就像有361条 RFC [功能建议文件]，而我也许只想要20条。我们需要坐下来，将它们全部看完，并忽略其中的解决方案，因为它们通常流于表象、视野狭隘。几乎每一条只针对一样事物，如若我们将它们全部拼凑起来，那简直是一堆垃圾。

> “掌握平衡时需要格外小心。毕竟在刚开始的时候总会有许多的好主意。”

所以我们必须基于人们在使用 Perl 5 时的真实感受重新整理，寻找统一、深层的解决方案。这些 RFC 文档许多都提到了一个事实，就是类型系统的不足。通过引入更条理分明的类型系统，我们可以解决很多问题并且即聪明又紧凑。

同时我们开始关注其他方面：如何统一特征集并开始重用不同领域的想法，这并不需要它们在下层相同。我们有一种标准的书写配对（pair）的方式——好吧，在 Perl 里面有两种！但使用冒号书写配对的方法同样可以用于基数计数法或是任何进制的文本编号。同样也可以用于其他形式的引用（quoting）。在 Perl 里我们称它为“奇妙的一致”。

> “做了 Perl 6 的早期实现的朋友们，握着我的手说：“我们真的很需要一位语言的设计者。””

同样的想法涌现出来，你说“我已经熟悉了语法如何运作，但是我看见它也被用在别处”，所以说视角相同才能找出这种一致。那些提出各种想法和做了 Perl 6 的早期实现的人们回来看我，握着我的手说：“我们真的需要一位语言的设计者。您能作为我们的[仁慈独裁者][4]（benevolent dictator）吗？”（LCTT 译注：Benevolent Dictator For Life，或 BDFL，指开源领袖，通常指对社区争议拥有最终裁决权的领袖，典故来自 Python 创始人  Guido van Rossum， 具体参考维基条目[解释][4]）

所以我是语言的设计者，但总是听到：“不要管具体实现（implementation）！我们目睹了你对 Perl 5 做的那些，我们不想历史重演！”真是让我忍俊不禁，因为他们作为起步的核心和原先 Perl 5 的内部结构上几乎别无二致，也许这就是为什么一些早期的实现做的并不好的原因。

因为我们仍然在摸索我们的整个设计，其实现在做了许多 VM （虚拟机）该做什么和不该做什么的假设，所以最终这个东西就像面向对象的汇编语言一样。类似的问题在伊始阶段无处不在。然后 Pugs 这家伙走过来说：“用用看 Haskell 吧，它能让你们清醒的认识自己正在干什么，让我们用它来弄清楚下层的语义模型（semantic model）。”

因此，我们明确了其中的一些语义模型，但更重要的是，我们开始建立符合那些语义模型的测试套件。在这之后，Parrot VM 继续进行开发，并且出现了另一个实现 Niecza ，它基于 .Net，是由一个年轻的家伙搞出来的。他很聪明，实现了 Perl 6 的一个很大的子集。不过他还是一个人干，并没有找到什么好方法让别人介入他的项目。

同时 Parrot 项目变得过于庞大，以至于任何人都不能真正的深入掌控它，并且很难重构。同时，开发 Rakudo 的人们觉得我们可能需要在更多平台上运行它，而不只是在 Parrot VM 上。 于是他们发明了所谓的可移植层 NQP ，即 “Not Quite Perl”。他们一开始将它移植到 JVM（Java虚拟机）上运行，与此同时，他们还秘密的开发了一个叫做 MoarVM 的 VM ，它去年才刚刚为人知晓。

无论 MoarVM 还是 JVM 在回归测试（regression test）中表现得十分接近 —— 在许多方面 Parrot 算是尾随其后。这样不挑剔 VM 真的很棒，我们也能开始考虑将 NQP 发扬光大。谷歌夏季编码大赛（Google Summer of Code project）的目标就是针对 JavaScript 的 NQP，这应该靠谱，因为 MoarVM 也同样使用 Node.js 作为日常处理。

我们可能要将今年余下的时光投在 MoarVM 上，直到 6.0 发布，方可休息片刻。

**LV：去年英国，政府开展编程年活动（Year of Code），来激发年轻人对编程的兴趣。针对活动的建议五花八门——类似为了让人们准确的认识到内存的使用你是否应该从低阶语言开始讲授，或是一门高阶语言。你对此作何看法？**

LW：到现在为止，Python 社区在低阶方面的教学工作做得比我们要好。我们也很想在这一方面做点什么，这也是我们有蝴蝶 logo 的部分原因，以此来吸引七岁大小的女孩子！

![Perl 6 : Camelia](https://upload.wikimedia.org/wikipedia/commons/thumb/8/85/Camelia.svg/640px-Camelia.svg.png)

> “到现在为止，Python 社区在低阶方面的教学工作做得比我们要好。”

我们认为将 Perl 6 作为第一门语言来学习是可行的。一大堆的将 Perl 5 作为第一门语言学习的人让我们吃惊。你知道，在 Perl 5 中有许多相当大的概念，如闭包，词法范围，和一些你通常在函数式编程中见到的特性。甚至在 Perl 6 中更是如此。

Perl 6 花了这么长时间的部分原因是我们尝试去坚持将近 50 种互不相同的原则，在设计语言的最后对于“哪点是最重要的规则”这个问题还是悬而未决。有太多的问题需要讨论。有时我们做出了决定，并已经工作了一段时间，才发现这个决定并不很正确。

之前我们并未针对并发程序设计或指定很多东西，直到 Jonathan Worthington 的出现，他非常巧妙的权衡了各个方面。他结合了一些其他语言诸如 Go 和 C# 的想法，将并发原语写的非常好。可组合性（Composability）是一个语言至关重要的一部分。

有很多的程序设计系统的并发和并行写的并不好 —— 比如线程和锁，不良的操作方式有很多。所以在我看来，额外花点时间看一下 Go 或者 C# 这种高阶原语的开发是很值得的 —— 那是一种关键字上的矛盾 —— 写的相当棒。

--------------------------------------------------------------------------------

via: http://www.linuxvoice.com/interview-larry-wall/

作者：[Mike Saunders][a]
译者：[martin2011qi](https://github.com/martin2011qi)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:http://www.linuxvoice.com/author/mike/
[1]:https://en.wikipedia.org/wiki/Perl#State_of_the_Onion
[2]:http://tinyurl.com/nhpr8g2
[3]:http://en.wikipedia.org/wiki/Self-clocking_signal
[4]:https://en.wikipedia.org/wiki/Benevolent_dictator_for_life