使用 Min 浏览器消除 web 噪音
============================================================
 ![Min Browser Muffles the Web's Noise](http://www.linuxinsider.com/ai/637666/browser-tabs.jpg) 

[Min][1] 是一款精简设计的 web 浏览器，功能简便，响应迅速。

在软件设计中，“简单”并不意味着功能低级、有待改进。你如果喜欢花哨工具比较少的文本编辑器和笔记程序，那么在 Min 浏览器中会有同样舒适的感觉。

我经常在台式机和笔记本电脑上使用 Google Chrome、Chromium 和 Firefox。我研究了它们的很多附加功能，所以我在长期的研究和工作中可以享用它们的特色服务。

然而，有时我希望有个快速、整洁的替代品来上网。随着多个项目的进行，我需要一个可以很快打开一大批选项卡甚至是独立窗口的强大浏览器。

我试过其他浏览器但很少能令我满意。替代品通常有一套独特的花哨的附件和功能，它们会让我开小差。

Min 浏览器就不这样。它是一个易于使用，并在 GitHub 开源的 web 浏览器，不会使我分心。

 ![Min browser ](http://www.linuxinsider.com/article_images/2017/84212_620x514.jpg) 
 
*Min 浏览器是精简的浏览器，提供了简单的功能以及快速的响应。只是不要指望马上能上手。*

### 它做些什么

Min 浏览器提供了 Debian Linux、Windows 和 Mac 机器的版本。它不能与功能众多的主流跨平台 web 浏览器竞争。

但它不必竞争，它很有名的原因应该是补充而不是取代那些主流浏览器。

其中一个主要原因是其内置的广告拦截功能。开箱即用的 Min 浏览器不需要配置或寻找兼容的第三方应用程序来拦截广告。

在 Edit/Preferences 菜单中，你可以通过三个选项来设置阻止的内容。它很容易修改屏蔽策略来满足你的喜好。阻止跟踪器和广告选项使用 EasyList 和 EasyPrivacy。 如果没有其他原因，请保持此选项选中。

你还可以阻止脚本和图像。这样做可以最大限度地提高网站加载速度，并能有效防御恶意代码。

### 按你的方式搜索

如果你在搜索上花费大量时间，你会喜欢 Min 处理搜索的方式。这是一个顶级的功能。

可以直接在浏览器的网址栏中使用搜索功能。Min 使用搜索引擎 DuckDuckGo 和维基百科的内容进行搜索。你可以直接在 web 地址栏中输入要搜索的东西。

这种方法很节省时间，因为你不必先进入搜索引擎窗口。 还有一个好处是可以搜索你的书签。

在 Edit/Preferences 菜单中，可以选择默认的搜索引擎。该列表包括 DuckDuckGo、Google、Bing、Yahoo、Baidu、Wikipedia 和 Yandex。

尝试将 DuckDuckGo 作为默认搜索引擎。 Min 默认使用这个引擎，但你也能更换。

 ![Min browser search function ](http://www.linuxinsider.com/article_images/2017/84212_620x466.jpg) 

*Min 浏览器的搜索功能是 URL 栏的一部分。Min 会使用搜索引擎 DuckDuckGo 和维基百科的内容。你可以直接在 web 地址栏中输入要搜索的东西。*

搜索栏会非常快速地显示问题的答案。它会使用 DuckDuckGo 的信息，包括维基百科条目、计算器和其它的内容。

它能快速提供片段、答案和网络建议。它有点像不是基于 Goolge 环境的替代品。

### 导航辅助

Min 允许你使用模糊搜索快速跳转到任何网站。它能立即向你提出建议。

我喜欢在当前标签旁边打开标签的方式。你不必设置此选项。它在默认情况下没有其他选择，但这也有道理。

 ![Min browser Tasks](http://www.linuxinsider.com/article_images/2017/84212_1200x750.jpg) 

*Min 的一个很酷的功能是将标签整理到任务栏中，这样你随时都可以搜索。*

不点击标签，过一会儿它就会消失。这使你可以专注于当前的任务，而不会分心。

Min 不需要附加工具来控制多个标签。浏览器会显示标签列表，并允许你将它们分组。

### 保持专注

Min 在“视图”菜单中有一个可选的“聚焦模式”。启用后，除了你打开的选项卡外，它会隐藏其它所有选项卡。 你必须返回到菜单，关闭“聚焦模式”，才能打开新选项卡。

任务功能还可以帮助你保持专注。你可以在 File 菜单或使用 `Ctrl+Shift+N` 创建任务。如果要打开新选项卡，可以在 File 菜单中选择该选项，或使用 `Control+T`。

按照你的风格打开新任务。我喜欢按组来管理和显示标签，这组标签与工作项目或研究的某些部分相关。我可以在任何时间重新打开整个列表，从而轻松快速的方式找到我的浏览记录。

另一个好用的功能是可以在选项卡区域找到段落对齐按钮。单击它启用阅读模式。此模式会保存文章以供将来参考，并删除页面上的一切，以便你可以专注于阅读任务。

### 并不完美

Min 浏览器并不是强大的，功能丰富的完美替代品。它有一些明显的缺点，开发人员花了很多时间也没有修正。

例如，它缺乏一个支持论坛和详细用户指南的开发人员网站。可能部分原因是它的官网在 GitHub，而不是一个独立的开发人员网站。尽管如此，对新用户而言这是一个缺点。

没有网站支持，用户被迫在 GitHub 上寻找自述文件和各种目录列表。你也可以在 Min 浏览器的帮助菜单中访问它们 - 但这没有太多帮助。

一个例子是当你启动浏览器时，屏幕会显示欢迎界面。它会显示两个按钮，一个人是 “Start Browsing”，另一个是 “Take a Tour.”。但是没有一个按钮可以使用。

但是，你可以通过单击 Min 窗口顶部的菜单栏开始浏览。但是，还没有解决缺少概览办法。

### 底线

Min 并不是一个功能完善、丰富的 web 浏览器。你在功能完善的主流浏览器中所用的插件和其它许多功能都不是 Min 的设计目标。然而，Min 在快速响应和免打扰方面很有用。

我越使用 Min 浏览器，我越觉得它高效 - 但是当你第一次使用它时要小心。

Min 并不复杂，也不难操作 - 它只是有点古怪。你必须要体验一下才能明白它如何使用。

### 想要提建议么？

有没有你建议回顾的 Linux 程序或发行版？有没有你爱的或者想要了解的？

请[在电子邮件中给我发送你的想法][3]，我会考虑将来在 “Linux Picks and Pans” 专栏上登出。

可以使用下方的读者评论功能说出你的想法！

--------------------------------------------------------------------------------

作者简介：

Jack M. Germain 从苹果 II 和 PC 的早期起就一直在写关于计算机技术。他仍然有他原来的 IBM PC-Jr 和一些其他遗留的 DOS 和 Windows 机器。他为 Linux 桌面的开源世界留下过共享软件。他运行几个版本的 Windows 和 Linux 操作系统，还通常不能决定是否用他的平板电脑、上网本或 Android 智能手机，还是用他的台式机或笔记本电脑。你可以在 Google+ 上与他联系。

--------------------------------------------------------------------------------

via: http://www.linuxinsider.com/story/84212.html

作者：[Jack M. Germain][a]
译者：[geekpi](https://github.com/geekpi)
校对：[GitFuture](https://github.com/GitFuture)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:http://www.linuxinsider.com/story/84212.html?rss=1#searchbyline
[1]:https://github.com/minbrowser/min/releases/
[2]:http://www.linuxinsider.com/article_images/2017/84212_1200x750.jpg
[3]:mailto:jack.germain@newsroom.ectnews.com
