给非英语母语的人从事开源项目的若干建议
====================================================

![Tips for non-native English speakers working on open source projects](https://opensource.com/sites/default/files/styles/image-full-size/public/images/life/world_hands_diversity.png?itok=LMT5xbxJ "Tips for non-native English speakers working on open source projects") 
 

大多数的开源项目的主要语言都是英语，但是开源项目的用户和贡献者却遍布全球。非英语母语的人在参与这个生态系统时会面临许多沟通和文化上的挑战。

在这篇文章中，作为不以英语为母语的 OpenStack 的贡献者的我们将会分享一些所面临挑战——如何去克服它们，还有一些好的方案，它们能够减轻不以英语为母语且刚开始从事的人的焦虑。我们的总部在日本、巴西和中国，每天都会与世界各地的大型 OpenStack 社区合作。

OpenStack 的官方语言是英语，这意味着我们是作为非英语为母语的人士来进行交流。

### 挑战

非英语为母语的人士在开源社区工作时会面临具体沟通挑战：它们与有限的语言技能和文化差异有关。

#### 语言技能

让我们来关注在阅读、写作、听力和口语背后的具体语言技能。

**阅读**：这是最简单也是最重要的技能。最简单是因为：如果你不明白写了什么，你有机会再次阅读它，或者需要的话可以多次阅读。如果你遇到了一个不常见的短语、表达式或者缩写，你可以使用一个词典或者翻译器。在另一方面，它是最重要的技能是因为：对大多数开源项目而言，主要的交流方式都是邮件列表和 IRC。

**写作**：英语语法是一个问题，尤其是对句子结构不同的语言而言。这可能会在用电子邮件进行通信和通过 IRC 频道进行通信时产生问题。对一些人来说，写出又长又漂亮的句子比较困难，而普遍依赖于简单句子，这是因为这些易于书写和理解。

**听力**：这对非英语为母语的人来说比阅读和写作更加困难。通常，英语为母语的人之间的对话在非常快的，这就使得那些仍然处于刚从事阶段的人很难理解他们的讨论，同时也限制了他们参与到讨论当中。此外，试图理解一个遍布全球的社区的各种口音也增加了复杂性。有意思的是，美国人的发音往往比其他的容易理解。

**口语**：口语比听力更加的困难，因为参与者的词汇量可能会比较有限。而且，英语的音素和语法通常与那些母语不是英语的人的母语相差很大，这就使得互动更加的难以理解。

#### 文化差异

在开源社区与其他人交流时，每种文化都有它自己不同的规范。例如，日本人通常不会明确的说好的或者不，他们认为这是尊重别人的一种方式，可以避免彼此间的争论。这通常与其他的文化大不一样，可能会对所表达的内容造成误解。

在中国文化中，人们倾向于只是说好的，而不是说不，或者试图商讨。在一个像 OpenStack 这样的分布于全球的社区里，这通常会导致在表达意见时缺乏自信。另外，中国人喜欢首先列出事实，然后在后面给出结论，而这会对来自其他文化中的人造成困惑，因为这不是他们所期望的。

例如，巴西人可能会认为讨论是以类似的方式进行的；然而，其他文化的反应会很直接和简短，这听起来可能会有点粗鲁。

### 克服障碍

语言技能方面的挑战要比文化差异方面的挑战容易克服。文化差异需要被受到尊重，然而英语技能却总是可以被改善的。

为了刷新你的语言技能，你应该尽可能多地接触该语言。不要担心你的局限，只管尽自己所能，你终将会得到改善。

尽可能多的阅读，因为这有助于你积累词汇。通过日常的聊天和邮件列表进行交流也很有帮助。一些工具，如实时字典和翻译器，对这些平台非常有用。

与别人或者你自己交谈可以帮助你更自如地频繁地说话。进行一对一的对话来表达你的想法比在更大的群体中讨论更容易。

### 新手的融入

来自新手和母语者的一些举措可能会对学习过程产生积极的影响。

#### 新手

说出和写下你的意见，并且提出你的问题；参与其中总是一个练习你的英语的很好的机会。不要害怕。

对于会议，确保你提前准备过，这样你将会对会议主题比较熟悉，而且会对自己要表达的意见更加的自信。

与英语为母语的人结交朋友，多和他们讨论来提高你的英语技能。

用英语写博客和技术文章也是不错的主意。

#### 给英语为母语的人士的建议

请说话慢一点儿，同时使用一些简单的单词和句子。如果你发现了非英语为母语的人使用英语中的一些错误请不要嘲笑他们，尝试鼓励新来的人表达自己的意见，让他们非常舒适地表达意见。

*这篇文章由 Masayuki Igawa、Dong Ma 和 Samuel de Medeiros Queiroz 共同协作完成，可以在 Hobart 的 linux.conf.au 2017([#lca2017][1])：[开源社区中的非英语母语者：一个真实的故事][2]中了解更多*

（ 题图：opensource.com）

-------------------------------------------

作者简介：

![](https://opensource.com/sites/default/files/styles/profile_pictures/public/pictures/myface_s.jpg?itok=-dy9_LQd)

Masayuki Igawa 是一名拥有 15 年大量软件项目经验的软件工程师，目前正在开发与 Linux 内核和虚拟化相关开源软件。自 2013 年起，他就一直是一名活跃的 OpenStack 项目贡献者。他是像 Tempest 和 subunit2sql 这样一些 OpenStack QA 项目的核心成员。他目前就职于 HPE 的 Upstream OpenStack 团队，该团队目的是使 OpenStack 更适合所有人。他以前曾在 OpenStack 峰会上发表演讲。

---

via: https://opensource.com/article/17/1/non-native-speakers-take-open-source-communities

作者：[Masayuki Igawa][a]
译者：[zhousiyu325](https://github.com/zhousiyu325)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/masayukig
[1]:https://twitter.com/search?q=%23lca2017&src=typd
[2]:https://linux.conf.au/schedule/presentation/70/