Linux 桌面系统的优势
============================================================

![linux-desktop-advantages](http://www.linuxinsider.com/article_images/story_graphics_xlarge/xl-2017-linux-1.jpg) 

当我放弃 Windows [转而使用 Linux 系统][3] 后，我的信心不断增长。出于安全方面的考虑促使我选用 Linux 系统，但是我很快发现了很多使用 Linux 桌面系统的优势。

对于那些还对 Linux 系统犹豫不决，或是那些不甚了解 Linux 系统的用户，我将通过这篇文章给大家介绍一些使用 Linux 桌面系统的优势。

### 免费才是王道

首先， Linux 系统完全免费。你无须为使用的操作系统或软件花费一分钱。除了免费获取软件产生的经济效益之外，你还可以在 Linux 系统中随意使用一些当前很流行的软件，比如文字处理软件和照片编辑软件——由于费用方面的原因，我们可能不太愿意花钱去购买这些软件。

微软的 Office 办公软件几乎是处理各种类型文档的一种标准软件了，但是它每年的费用竟高达 70 美元。然而，你却可以免费使用 [LibreOffice][4] 软件来代替，它同样可以处理各种类型的文档，而且使用也很方便。

免费软件还能让您有机会尝试新的功能，并通过它们寻求商务和休闲的新方式，而且你也不需要支付任何预期的费用。

与其费尽周折的去衡量 Mac 或 Windows 系统的优点，你可以考虑下在[上百款不同风格的 Linux 发行版][5]中选择一款最适合自己的操作系统。

Linux 系统甚至在硬件方面也为用户节省了不少钱，比如有些厂商——尤其是戴尔公司——为购买预安装了 Linux 系统的电脑的用户提供打折优惠。这些电脑的价格相对来说比较便宜，因为用户无须再花钱购买微软的 Windows 系统许可证。

### 随心所欲的系统定制

其次，在 Linux 系统中，你可以对系统功能进行任意更改。 Linux 生态系统中的核心项目之一就是桌面环境——它是一些由基础的用户程序和可视化元素组成的一个集合，比如状态栏和启动器，这些元素构成了用户与计算机的一个交互界面。

有些 Linux 发行版还预安装了桌面环境。比如， Ubuntu 系统就预安装了 Unity 桌面。其它系统，比如 Debian 会在系统安装的过程中让用户选择需要的桌面环境。总之，在 Linux 系统中，用户都可以随意更换他们喜欢的桌面环境。

大多数的 Linux 发行版都支持（也就是兼容）那些非常流行的桌面环境，因此，找到一款适合自己的桌面系统也非常容易。在桌面系统这个万花筒里，你可以找到界面华丽的系统桌面，比如 KDE Plasma 或者 [Gnome][6]，以及轻量级的系统桌面，比如 Xfce 和 MATE 桌面。使用任一款系统桌面，你都可以通过更改主题、系统托盘和菜单，以及仿照其它用户的桌面环境来进一步定制自己的桌面环境。

Linux 系统的可定制特性完全超出你的想象力。如果你更看重系统的稳定性，你可以使用 Mint 这个发行版系统，它对硬件的兼容性非常好，而且也能确保系统顺利更新。

除此之外，如果你希望及时领略前沿，你可以安装 Arch Linux ，每一款软件只要开发者一发布，你就可以进行得到最新更新。

如果你介乎于两者之间，既想要稳定的系统，也想运行一些几个崭新的程序，你可以下载程序的源代码（程序员所开发的代码文件），然后自己进行编译。这就需要你使用工具来编译源代码，生成一堆你的电脑可以运行的 0 和 1 组成的二进制文件。

你可以使用自己喜欢的任何方式去折腾属于自己的 Linux 系统。

### 无与伦比的安全性

第三，多才多艺的 Linux 系统还有一个更重要的特性：安全。

起初，尽管有一些针对 Linux 系统的病毒，但是跟 Mac 系统比起来，已经屈指可数了。更重要的是，实际上 Linux 系统的核心代码是开源的，对用户完全透明，这意味着你的 Linux 系统漏洞更少。

一些专有（比如，不开源）的操作系统被任务会影响用户安全，因为它们会启动一些实现方式糟糕的、不透明的进程，从而造成了巨大的威胁。

比如说， Windows 系统在升级的过程中，默认情况下[不会检查加密签名][7]来验证更新文件的可靠性。

而使用 Linux 系统，你可以在选择更新时通过签名检查进行严格的细粒度控制，大多数的发行版在系统更新时都默认强制安全检查。这种责任感源自于 Linux 系统的开源开发模式所带来的透明度。

像 Arch Linux 这种滚动发行版则增加了更多的安全性设置，因为一些重要的补丁一旦通过验证， Arch Linux 就会马上可以使用。你可能很难找到那些每天都提供更新的单一主流操作系统，但是这样的 Linux 发行版却有很多。

### 天生的编程环境

很多开发者或者任何对编程有兴趣的人都得益于 Linux 桌面系统中集成的强大开发工具。其中包括那些最经典的编程工具，比如 GNU C 编译器，或者 GCC 和 GNU Autoconf 工具都是 Linux 系统中一些非常重要的基础工具。

Linux 系统的大多数默认软件库都支持数十种编程语言，它包含了发行版中可以使用的预编译软件。

很多因特网的基础架构和许多联网设备都运行于 Linux 系统上——从服务器到智能设备，比如安防摄像机和恒温器。在 Linux 系统下开发调试这些设备的软件非常容易。如果你有一个跟计算机相关的项目， Linux 系统可以完美地支持你完成这个项目。

### 社区是 Linux 系统发展的关键

最后一点， Linux 系统拥有一个团结且友好型的社区。由于 Linux 在桌面系统是一个相对小众的桌面操作系统，仅占有 3% 左右的市场份额，因此， Linux 社区更希望有更多的潜在用户加入进来。

Linux 系统有很多的用户论坛，尤其是对新手比较友好的 Unbuntu 系统论坛，它包括非常丰富且全面的知识来帮助用户解决一些基本的系统问题。很多高级用户更倾向于使用 Linux 系统，因此那些 Linux 发行版都拥有非常非常详尽维基文档，以指导用户完成高级的系统应用项目。

甚至还有业余的 Linux 论坛和 [Reddit] [8] 讨论区，所涉及的范围包括从对比 Linux 系统各种应用软件到炫耀桌面主题等。总而言之，这是一个比 Windows 用户群更加友善的社区。

我沉浸在 Linux 的世界里两年多了，我更加相信 Linux 系统对每一个用户都有所帮助。我希望这篇文章能够让你了解到 Linux 桌面系统的各种优势。但是真正的乐趣是从中发现自己感兴趣的东西！

--------------------------------------------------------------------------------

via: http://www.linuxinsider.com/story/84326.html

作者：[Jonathan Terrasi][a]
译者：[rusking](https://github.com/rusking)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:http://www.linkedin.com/company/ect-news-network
[1]:http://www.linuxinsider.com/story/84326.html?rss=1#
[2]:http://www.linuxinsider.com/perl/mailit/?id=84326
[3]:http://www.linuxinsider.com/story/84286.html
[4]:http://www.libreoffice.org/
[5]:https://en.wikipedia.org/wiki/Linux_distribution
[6]:http://en.wikipedia.org/wiki/GNOME
[7]:https://duo.com/blog/out-of-box-exploitation-a-security-analysis-of-oem-updaters
[8]:http://www.reddit.com/
